/*
First Course in Java, EDP 135277
Homework # 7
Sean Savage

The following code demonstrates declaration and implementation of an abstract class.

Sample output:

   Batch1, of Chocolate Chip Cookies:
           Baking... Done. Now doesn't the house smell good?
           These here cookies are mighty tasty.
   -- Later that week... --
           This has been sitting around too long; it went stale.

   Batch2, a Chicken Pot Pie:
           Baking... Done. Now doesn't the house smell good?
           Mmm... Tastes just like chicken.
   -- Later that week... --
           Yuck! Say no to Salmonilla and throw out this rotten pie.

   Batch3, of Crack:
           Baking... Done. Now this place smells like a crackhouse.
           Smoking... You're high now, and well on your way to a life of misery.

   Press any key to continue . . .
*/

abstract class BakedGoods {

/*

I wouldn't want to instantiate a "baked good," and I want to make all my talented yet absent-minded baker/coder Ooompa-Loompas who build upon this code in the future to specify what sort of baked good they're creating; I can do this by marking my BakedGoods class "abstract."  Now nobody can instantiate this class; they have to instantiate a member of a child class of this class.  (For instance, they have to make a batch of chocolate chip cookies or something, not just a generic batch of baked goods.)

All baked goods can bake, burn, or go stale, so I specify those methods here.

Note that not all baked goods can taste good (crack, for instance, presumably never tastes good.)  So there's no abstract tasteGood() method here.

*/
   public void bake() {
      System.out.println(" Baking... Done. Now doesn't the house smell good?");
   }

   public void burn() {
      System.out.println(" Oops, it came out a tad well-done.");
   }

   public void goStale() {
      System.out.println("-- Later that week... --");
      System.out.println(" This has been sitting around too long; it went stale.");
   }
}

class ChocolateChipCookies extends BakedGoods {

   public void tasteGood() { // Not only can a batch of chocolate chip cookies taste good, but if it does taste good, it tastes good in a way different from other baked goods.
         System.out.println(" These here cookies are mighty tasty.");

   }

}

class ChickenPotPie extends BakedGoods {

   public void tasteGood() { // This type of baked good, if cooked right, also tastes good in its own unique way.
         System.out.println(" Mmm... Tastes just like chicken.");

   }
   public void goStale() { // When ChickenPotPie goes stale, certain nasty things occur that don't happen with your typical bakery fare. So it has its own goStale() method that overrides the parent method of the same name (which will be hidden when a chicken pot pie is created).
      System.out.println("-- Later that week... --");
      System.out.println(" Yuck! Say no to Salmonilla and throw out this rotten pie.");
   }
}

class Crack extends BakedGoods { // Note that

   public void bake() {  // Crack doesn't smell quite so good as other baked goods while baking; so it has a special bake() method that overrides the generic abstract BakedGoods bake() method.
      System.out.println(" Baking... Done. Now this place smells like a crackhouse.");
   }

   public void burn() { // The same goes for burn()!
      System.out.println(" Smoking... You're high now, and well on your way to a life of misery.");
   }

}


class BakedGoodsTestDrive {

   public static void main(String [] args) {

      ChocolateChipCookies batch1;
      System.out.println("Batch1, of Chocolate Chip Cookies:");
      batch1 = new ChocolateChipCookies();
      batch1.bake();
      batch1.tasteGood();

      batch1.goStale();
      System.out.println();

      ChickenPotPie batch2;
      System.out.println("Batch2, a Chicken Pot Pie:");
      batch2 = new ChickenPotPie();
      batch2.bake();
      batch2.tasteGood();
      batch2.goStale();
      System.out.println();

      System.out.println("Batch3, of Crack:");
      Crack batch3;
      batch3 = new Crack();
      batch3.bake();
      batch3.burn();
      System.out.println();

   }

}
