abstract class RacePace {

   private double distance;
   private int hours;
   private int minutes;
   private int seconds;
   private double total_mins;

   //default constructor
   RacePace() {
      distance=0.0;
      hours=minutes=seconds=0;
   }

   //Parameterized constructor
   RacePace(double d, int h, int m, int s) {
      distance = d;
      hours = h;
      minutes = m;
      seconds = s;
   }

   //Accessor methods
   double getDistance() { return distance; }
   double getTotalMinutes() { return goalInMins(hours, minutes, seconds); }
   int getHours() { return hours; }
   int getMinutes() { return minutes; }
   int getSeconds() { return seconds; }

   void setDistance(double d) { distance = d; }
   void setTotalMinutes(double total_mins) { total_mins = goalInMins(hours, minutes, seconds); }
   void setHours(int h) { hours = h; }
   void setMinutes(int m) { minutes = m; }
   void setSeconds(int s) { seconds = s; }

   //here's my abstract method
   abstract double calcPace();


   double goalInMins(int hr, int min, int sec) {  //returns the value of the goal converted to minutes.
       int hours, minutes, seconds;
       double total_mins, pace;
       hours = hr;
       minutes = min;
       seconds = sec;
       total_mins = (hours*60) + minutes + (seconds/60); // calculate total goal time in minutes
       return total_mins;
    }
}


//Subclass of RacePace - here race measured in miles
class RaceMiles extends RacePace {
   //default constructor
   RaceMiles() {
      super(); //calls superclass constructor
   }

   RaceMiles(double d, int h, int m, int s) {
      super(d,h,m,s); //calls superclass constructor with 4 parameters)
   }

   double calcPace() {
      double pace = getTotalMinutes()/getDistance();
      return(pace);
   }
}


//Subclass of RacePace - here race measured in kilometers
class RaceKilometers extends RacePace {
   //default constructor
   RaceKilometers() {
      super(); //calls superclass constructor
   }

   RaceKilometers(double d, int h, int m, int s) {
      super(d,h,m,s); //calls superclass constructor with 4 parameters)
   }

   double calcPace() {
      double pace = getTotalMinutes()/getDistance()*1.609647;
      return pace;
   }
}


class EasyPaceCalculator {
   public static void main(String args[]) {
      int hours;
      int minutes;
      int seconds;
      double distance;

      RaceMiles marathon = new RaceMiles(26.2,3,30,0);
      RaceKilometers ten_k = new RaceKilometers(10.0,0,45,0);

      distance = marathon.getDistance();
      hours = marathon.getHours();
      minutes = marathon.getMinutes();
      System.out.println("In order to run " + distance + " in /n" );
      System.out.println( hours + " hours " + minutes + " minutes, /n" );
       System.out.println("Your target marathon pace is " + marathon.calcPace() + " minutes per mile.\n");

      distance = ten_k.getDistance();
      hours = ten_k.getHours();
      minutes = ten_k.getMinutes();
      System.out.println("In order to run " + distance + " in /n" );
      System.out.println( hours + " hours " + minutes + " minutes, /n" );
       System.out.println("your target 10k pace is " + ten_k.calcPace() + " minutes per mile.\n");
   }
}