// Demonstrate that the finally block gets executed whether or not an exception occurs.
class FinallyDemo {
  // Throw an exception within of the method.
  static void procA() {
    try {
      System.out.println("inside procA");
      throw new RuntimeException("demo");
    } finally {
      System.out.println("inside procA's finally, which executes even if an exception occured. The caller, main, has not yet handled the exception.");

    }
  }

  // Return from within a try block.
  static void procB() {
    try {
      System.out.println("inside procB");
      return;
    } finally {
      System.out.println("procB's finally, which executes even though no error occurred");
    }
  }

  // Execute a try block normally.
  static void procC() {
    try {
      System.out.println("inside procC");
    } finally {
      System.out.println("procC's finally, which executes even though no error occurred");
    }
  }

  public static void main(String args[]) {
    try {
      procA();
    } catch (Exception e) {
      System.out.println("Exception in the first method is caught in main. Because the exception is handled gracefully, execution can continue to other method calls.");
    }
    procB();
    procC();
  }
}
