/*
First Course in Java, EDP 135277
Homework 5 - version with assigned value for PI
[EDITED TO USE THE PI PROPERTY OF THE MATH CLASS]
Kathy Kunitake

Sample output:

This program will calculate the volume and surface area
of the shape you select using the dimensions you enter.

Choose a shape:

1. Sphere
2. Right circular cylinder
3. Right circular cone

Enter a number to select your shape or 'quit' to end the program: 1

Enter the radius of the sphere in centimeters: -1

The volume of your figure is: 4.188666666666667 cubic centimeters.
The surface area of your figure is: 12.566 square centimeters.

Choose a shape:

1. Sphere
2. Right circular cylinder
3. Right circular cone

Enter a number to select your shape or 'quit' to end the program:
*/

import java.io.*;
import java.text.*;

/*
   The program ThreeDFigureDemo computes the volumes and surface areas for
   selected figures based upon dimensions input by the user. The program will
   convert negative values entered by the user to non-negative values.
*/

class ThreeDFigureDemo
{
   public static void main(String[] args)
   {
      String str;
            String inputLine;
            double l, h, r;
            DecimalFormat df;
            Number n;

            df = new DecimalFormat();
            try
            {
               BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

               System.out.println("This program will calculate the volume and surface area\nof the shape you select using the dimensions you enter.\n");

               do
               {
                  System.out.println("Choose a shape:\n");
                  System.out.println("1. Sphere");
                  System.out.println("2. Right circular cylinder");
                  System.out.println("3. Right circular cone\n");
                  System.out.print("Enter a number to select your shape or 'quit' to end the program: ");

                  str = br.readLine();
                  System.out.println("");

                  if(str.equals("1"))
                  {
                     System.out.print("Enter the radius of the sphere in centimeters: ");
                     inputLine = br.readLine();
                     n = df.parse(inputLine);
                     r = n.doubleValue();

                     Sphere s = new Sphere(r);
                     System.out.println("");
                     System.out.println("The volume of your figure is: " + s.volume() + " cubic centimeters.");
                     System.out.println("The surface area of your figure is: " + s.surfaceArea() + " square centimeters.");
                  }

                  else if(str.equals("2"))
                  {
                     System.out.print("Enter the height of the right circular cylinder: ");
                     inputLine = br.readLine();
                     n = df.parse(inputLine);
                     h = n.doubleValue();

                     System.out.print("Enter the radius of the right circular cylinder: ");
                     inputLine = br.readLine();
                     n = df.parse(inputLine);
                     r = n.doubleValue();

                     RightCircularCylinder rcCylinder = new RightCircularCylinder(h, r);
                     System.out.println("");
                     System.out.println("The volume of your figure is: " + rcCylinder.volume() + " cubic centimeters.");
                     System.out.println("The surface area of your figure is: " + rcCylinder.surfaceArea() + " square centimeters.");
                  }

                  else if(str.equals("3"))
                  {
                     System.out.print("Enter the length of the right circular cone: ");
                     inputLine = br.readLine();
                     n = df.parse(inputLine);
                     l = n.doubleValue();

                     System.out.print("Enter the height of the right circular cone: ");
                     inputLine = br.readLine();
                     n = df.parse(inputLine);
                     h = n.doubleValue();

                     System.out.print("Enter the radius of the right circular cone: ");
                     inputLine = br.readLine();
                     n = df.parse(inputLine);
                     r = n.doubleValue();

                     RightCircularCone rcCone = new RightCircularCone(l, h, r);
                     System.out.println("");
                     System.out.println("The volume of your figure is: " + rcCone.volume() + " cubic centimeters.");
                     System.out.println("The surface area of your figure is: " + rcCone.surfaceArea() + " square centimeters.");
                  }

                  else if(str.equals("quit"))
                  {
                     break;
                  }

                  else
                  {
                     System.out.println("Your entry is invalid. Please try again.");
                  }

                  System.out.println("");

               }while(!str.equals("quit"));
            }
            catch(IOException e)
            {
               System.out.println("I/O Exception" + e);
            }
            catch(ParseException e)
            {
               System.out.println("Parse Exception" + e);
      }
   }
}


abstract class ThreeDFigure
{
   private double length;  //length of figure in centimeters
   private double height;  //height of figure in centimeters
   private double radius;  //radius of figure or base of figure in centimeters

   double getLength()
   {
      return length;
   }

   double getHeight()
   {
      return height;
   }

   double getRadius()
   {
      return radius;
   }

   void setLength(double l)
   {
      if(l >= 0) length = l;
      else length = -1 * l;   //length of figure to be non-negative
   }

   void setHeight(double h)
   {
      if(h >= 0) height = h;
      else height = -1 * h;   //height of figure to be non-negative
   }

   void setRadius(double r)
   {
      if(r >= 0) radius = r;  //radius of figure to be non-negative
      else radius = -1 * r;
   }

   abstract double volume();

   abstract double surfaceArea();
}


class Sphere extends ThreeDFigure
{
   //final double PI = 3.14159265358979323846;

   Sphere(double r)
   {
      setRadius(r);
   }

   double volume()
   {
      return Math.PI*getRadius()*getRadius()*getRadius()*4/3; //returns volume in cubic centimeters
   }

   double surfaceArea()
   {
      return 4*Math.PI*getRadius()*getRadius();   //returns surface area in square centimeters
   }
}


class RightCircularCylinder extends ThreeDFigure
{
   //final double PI = 3.14159265358979323846;

   RightCircularCylinder(double h, double r)
   {
      setHeight(h);
      setRadius(r);
   }

   double volume()
   {
      return Math.PI*getRadius()*getRadius()*getHeight();  //returns volume in cubic centimeters
   }

   double surfaceArea()
   {
      return 2*Math.PI*getRadius()*getHeight();   //returns surface area in square centimeters
   }
}

class RightCircularCone extends ThreeDFigure
{
   //final double PI = 3.14159265358979323846;

   RightCircularCone(double l, double h, double r)
   {
      setLength(l);
      setHeight(h);
      setRadius(r);
   }

   double volume()
   {
      return Math.PI*getRadius()*getRadius()*getHeight()*1/3; //returns volume in cubic centimeters
   }

   double surfaceArea()
   {
      return Math.PI*getRadius()*getLength();  //returns surface area in square centimeters
   }
}
